/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2016. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.CheckBox");
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.CheckboxTree");
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.CheckboxTreeNode");
dojo.require("com.ibm.team.scm.web.ui.internal.process.ProcessSpecificationConstants");
dojo.require("com.ibm.team.scm.web.ui.internal.process.ScmClient");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.MessageDisplayWidget");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.StreamComponentsPreconditionRepresentation");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("jazz.ui.Tree");
dojo.require("jazz.ui.tree.IconItem");

dojo.requireLocalization("com.ibm.team.scm.web.ui.internal.process", "OperationBehaviorMessages");

(function() {
var OperationBehaviorMessages= dojo.i18n.getLocalization("com.ibm.team.scm.web.ui.internal.process", "OperationBehaviorMessages");

var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var ServiceResponseHandler= team.repository.web.transport.ServiceResponseHandler;
var widgets= team.rtc.foundation.web.ui.widgets;
var CheckBox= widgets.CheckBox;
var CheckboxTree= widgets.CheckboxTree;
var CheckboxTreeNode= widgets.CheckboxTreeNode;
var CheckBoxTreeNodeState= CheckboxTreeNode.CheckBoxTreeNodeState;
var process= team.scm.web.ui.internal.process;
var ProcessSpecificationConstants= process.ProcessSpecificationConstants;
var ScmClient= process.ScmClient;
var operationbehavior= process.operationbehavior;
var MessageDisplayWidget= operationbehavior.MessageDisplayWidget;
var StreamComponentsPermissionWrapper= operationbehavior.StreamComponentsPreconditionRepresentation.StreamComponentsPermissionWrapper;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var keys= dojo.keys;
var Tree= jazz.ui.Tree;
var IconItem= jazz.ui.tree.IconItem;

/**
 * This widget displays the project area hierarchy and on selection of the
 * process area in this hierarchy, the roles configured in the selected process
 * area is presented to the user.
 * 
 * The result from this widget is a map of selected roles stored against the
 * corresponding process area.
 * 
 */
dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget", [ _Widget, _Templated], {

	templatePath: dojo.moduleUrl(ProcessSpecificationConstants.MODULE_URL, ProcessSpecificationConstants.WIDGET_BASE + "EditComponentsPermissionWidget.html"),

	//_messages: null,

	//_projectHierarchyContainer: null,

	//_rolesContainer: null,

	//_componentOwnerCheckBoxContainer: null,

	//_selectedProcessAreaName: null,

	//_messagesDiv: null,

	//_rolesCheckBoxMap: null,

	//_componentOwnerCheckBox: null,

	//_projectAreaHierarchyTree: null,

	//_messageDisplayWidget: null,

	//_projectAreaId: null,

	//_configuredPermission: null,

	//_inputModel: null,

	//_connectHandles: null,

	//_hasPermissionChanged: null,

	//_permissionChangedHandler: null,

	//_currentSelection: null,

	//_currentRolesCheckboxList: null,

	constructor: function(params) {
		this._messages= OperationBehaviorMessages;
		this._rolesCheckBoxMap= {};
		this._connectHandles= [];
		this._hasPermissionChanged= false;
		this._projectAreaId= params.projectAreaId;
		this._configuredPermission= params.configuredPermissions;
		this._permissionChangedHandler= params.permissionChangeHandler;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []);
		this._messageDisplayWidget= new MessageDisplayWidget();
		dojo.place(this._messageDisplayWidget.domNode, this._messagesDiv);
		this._messageDisplayWidget.showProgressMessage(OperationBehaviorMessages.EditComponentsPermission_messageLoadingProjectArea);
		this._projectAreaHierarchyTree= new Tree();
		this._connectHandles.push(dojo.connect(this._projectAreaHierarchyTree, "onSelectionChanged", this, "_handleProcessAreaSelectionChanged"));
		dojo.place(this._projectAreaHierarchyTree.domNode, this._projectHierarchyContainer);
		var params= {};
		params.label= OperationBehaviorMessages.EditComponentsPermission_allowComponentOwnerText;
		if (this._configuredPermission != null) {
			params.checked= this._configuredPermission.allowDeliverAccessToOwner();
		}
		params.onClickHandler= dojo.hitch(this, function(event) {
			this._permissionChanged();
			return false;
		});
		this._componentOwnerCheckBox= new CheckBox(params);
		dojo.place(this._componentOwnerCheckBox.domNode, this._componentOwnerCheckBoxContainer);
		this._fetchAndInitializeProjectAreaHierarchyTree();
	},

	destroy: function(preserveDom) {
		if (this._rolesCheckBoxMap != null) {
			var $subject= jdojo.getValues(this._rolesCheckBoxMap);
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var rolesCheckBoxList= $subject[$count];
				this._removeChildren(rolesCheckBoxList);
				rolesCheckBoxList.destroy(preserveDom);
				this._rolesCheckBoxMap= null;
			}
		}
		if (this._projectAreaHierarchyTree != null) {
			this._removeChildren(this._projectAreaHierarchyTree);
			this._projectAreaHierarchyTree.destroy(preserveDom);
			this._projectAreaHierarchyTree= null;
		}
		if (this._componentOwnerCheckBox != null) {
			this._componentOwnerCheckBox.destroy(preserveDom);
			this._componentOwnerCheckBox= null;
		}
		var $subject2= this._connectHandles;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var connectHandle= $subject2[$count2];
			dojo.disconnect(connectHandle);
		}
		if (this._messageDisplayWidget != null) {
			this._messageDisplayWidget.destroy(preserveDom);
			this._messageDisplayWidget= null;
		}
		this.inherited("destroy", arguments, [preserveDom]);
	},

	getStreamComponentsPermission: function() {
		var permissions= this._configuredPermission;
		if (this._hasPermissionChanged) {
			var allowDeliverAccessToOwner= this._componentOwnerCheckBox.isChecked();
			var processAreaRoleMap= this._configuredPermission != null ? this._configuredPermission.getProcessAreaRoleMap() : {};
			processAreaRoleMap= this._inputModel.getCurrentProcessAreaRoleMap();
			permissions= new StreamComponentsPermissionWrapper(allowDeliverAccessToOwner, processAreaRoleMap);
		}
		return permissions;
	},

	_permissionChanged: function() {
		this._hasPermissionChanged= true;
		this._permissionChangedHandler();
	},

	_fetchAndInitializeProjectAreaHierarchyTree: function() {
		var projectAreaId= {};
		projectAreaId.itemID= this._projectAreaId;
		projectAreaId.includeDetailsForChildren= ProcessSpecificationConstants.VAL_TRUE;
		var _onSuccess= dojo.hitch(this, "_onProjectHierarchyFetchSuccess");
		var _onFailure= dojo.hitch(this, "_onFailure");
		var projectHierarchyResponseHandler= new ServiceResponseHandler({'onSuccess': _onSuccess, 'onFailure': _onFailure}, 'onSuccess', 'onFailure');
		ScmClient.getProcessAreaRolesAndHierarchy(projectHierarchyResponseHandler, projectAreaId);
	},

	_onProjectHierarchyFetchSuccess: function(projectHierarchy) {
		this._messageDisplayWidget.hideProgressMessage();
		var params= {};
		params.projectHierarchy= projectHierarchy;
		if (this._configuredPermission != null) {
			params.processAreaRolesMap= this._configuredPermission.getProcessAreaRoleMap();
		}
		params.modelChangeHandler= dojo.hitch(this, "_permissionChanged");
		this._inputModel= new ProjectHierarchyPermissionTreeModel(params);
		var rootItem= this._inputModel.getRootElement();
		this._setTreeOnItemAndItsChildren(this._inputModel.getRootElement());
		this._projectAreaHierarchyTree.addChild(this._inputModel.getRootElement(), 0);
		rootItem.setExpanded(true);
		this._projectAreaHierarchyTree.setSelection(rootItem);
	},

	_onFailure: function(error) {
		console.error(error);
		this._messageDisplayWidget.showTeamRepositoryExceptionMessage(error);
	},

	_setTreeOnItemAndItsChildren: function(item) {
		item.tree= this._projectAreaHierarchyTree;
		var $subject3= item.getChildren();
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var childEntry= $subject3[$count3];
			this._setTreeOnItemAndItsChildren(childEntry);
		}
	},

	_handleProcessAreaSelectionChanged: function(selection) {
		var processAreaModelEntry= selection[0];
		if (this._currentSelection != null && (this._currentSelection.getProcessArea().itemID === processAreaModelEntry.getProcessArea().itemID)) {
			return ;
		}
		var paLabel= dojo.string.substitute(OperationBehaviorMessages.EditComponentsPermission_selectRolesText, [ processAreaModelEntry.getProcessArea().name ]) ;
		dojo.place(dojo.doc.createTextNode(paLabel), this._selectedProcessAreaName, 'only');
		this._updateRoles(processAreaModelEntry);
		this._currentSelection= processAreaModelEntry;
	},

	_updateRoles: function(processAreaModelEntry) {
		var rolesCheckBoxList= this._rolesCheckBoxMap[processAreaModelEntry.getProcessArea().itemID];
		if (rolesCheckBoxList == null && processAreaModelEntry.getDefinedRoles() != null) {
			rolesCheckBoxList= new CheckboxTree();
			var roles= processAreaModelEntry.getDefinedRoles();
			var configuredRoles= processAreaModelEntry.getConfiguredRoles();
			var count= 0;
			var $subject4= roles;
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var role= $subject4[$count4];
				var params= {};
				if (role.name == null || role.name === "") {
					params.label= jazz.util.html.escape(role.id);
				} else {
					params.label= jazz.util.html.escape(role.name);
				}
				params.itemId= role.id;
				params.tag= role;
				if (configuredRoles != null && dojo.indexOf(configuredRoles, role.id) !== -1) {
					params.itemState= CheckBoxTreeNodeState.SELECTED;
				} else {
					params.itemState= CheckBoxTreeNodeState.UNSELECTED;
				}
				var node= new CheckboxTreeNode(params);
				this._connectHandles.push(dojo.connect(node.getCheckBoxNodeElement(), 'click', dojo.hitch(new CheckBoxMouseEventHandler(node, processAreaModelEntry), 'handle')), dojo.connect(node.getCheckBoxNodeContainer(), 'keydown', dojo.hitch(new CheckBoxKeyEventHandler(node, processAreaModelEntry), 'handle')));
				rolesCheckBoxList.addChild(node, count++);
			}
			this._rolesCheckBoxMap[processAreaModelEntry.getProcessArea().itemID]= rolesCheckBoxList;
		}
		if (this._currentRolesCheckboxList == null) {
			this._rolesContainer.appendChild(rolesCheckBoxList.domNode);
		} else {
			this._rolesContainer.replaceChild(rolesCheckBoxList.domNode, this._currentRolesCheckboxList.domNode);
		}
		this._currentRolesCheckboxList= rolesCheckBoxList;
	},

	_removeChildren: function(tree) {
		var children= tree.getChildren();
		if (children != null) {
			var clonedChildren= [];
			var $subject5= children;
			var $length5= $subject5.length;
			for (var $count5= 0; $count5 < $length5; $count5++){
				var childNode= $subject5[$count5];
				clonedChildren.push(childNode);
			}
			var $subject6= clonedChildren;
			var $length6= $subject6.length;
			for (var $count6= 0; $count6 < $length6; $count6++){
				var clonedChild= $subject6[$count6];
				tree.removeChild(clonedChild, false);
			}
		}
	}
});
var CheckBoxSelectionHandler= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget.CheckBoxSelectionHandler", null, {
	"-chains-": { constructor: "manual" },

	//_node: null,

	//_processAreaModelEntry: null,

	constructor: function(node, processAreaModelEntry) {
		this._processAreaModelEntry= processAreaModelEntry;
		this._node= node;
	},

	handleRoleSelectionChanged: function() {
		var configuredRoles= this._processAreaModelEntry.getConfiguredRoles();
		if (configuredRoles == null) {
			configuredRoles= [];
		}
		var roleId= this._node.getTagObject().id;
		if (dojo.indexOf(configuredRoles, roleId) !== -1 && (this._node.getItemState() === CheckBoxTreeNodeState.UNSELECTED)) {
			var index= dojo.indexOf(configuredRoles, roleId);
			configuredRoles.splice(index, 1);
		} else if (this._node.getItemState() === CheckBoxTreeNodeState.SELECTED) {
			configuredRoles.push(roleId);
		}
		this._processAreaModelEntry.updateConfiguredRoles(configuredRoles);
	}
});
var CheckBoxMouseEventHandler= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget.CheckBoxMouseEventHandler", CheckBoxSelectionHandler, {

	constructor: function(node, processAreaModelEntry) {
		this.inherited(arguments, [node, processAreaModelEntry]);
	},

	handle: function(event) {
		this.handleRoleSelectionChanged();
	},

	$interfaces: {
		'com.ibm.jdojo.dom.events.IEventHandler': true
	}
});
var CheckBoxKeyEventHandler= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget.CheckBoxKeyEventHandler", CheckBoxSelectionHandler, {

	constructor: function(node, processAreaModelEntry) {
		this.inherited(arguments, [node, processAreaModelEntry]);
	},

	handle: function(event) {
		if (keys.SPACE === event.keyCode) {
			this.handleRoleSelectionChanged();
		}
	},

	$interfaces: {
		'com.ibm.jdojo.dom.events.IEventHandler': true
	}
});
var ProjectHierarchyPermissionTreeModel= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget.ProjectHierarchyPermissionTreeModel", null, {
	"-chains-": { constructor: "manual" },

	//_projectArea: null,

	//_processAreaRoleMap: null,

	//_rootElement: null,

	//_modelChangeHandler: null,

	constructor: function(params) {
		this._projectArea= params.projectHierarchy;
		this._processAreaRoleMap= params.processAreaRolesMap;
		this._modelChangeHandler= params.modelChangeHandler;
		if (this._processAreaRoleMap == null) {
			this._processAreaRoleMap= {};
		}
		this._initializeModelEntries();
	},

	getRootElement: function() {
		return this._rootElement;
	},

	getCurrentProcessAreaRoleMap: function() {
		var processAreaRoleMap= {};
		this.recursivelyUpdateProcessAreaRoleMap(this._rootElement, processAreaRoleMap);
		return processAreaRoleMap;
	},

	notifyModelChanged: function() {
		this._modelChangeHandler();
	},

	recursivelyUpdateProcessAreaRoleMap: function(modelEntry, processAreaRoleMap) {
		var configuredRoles= modelEntry.getConfiguredRoles();
		if (configuredRoles != null && configuredRoles.length > 0) {
			processAreaRoleMap[modelEntry.getProcessAreaPath()]= configuredRoles;
		}
		var children= modelEntry.getChildren();
		if (children != null && children.length > 0) {
			var $subject7= children;
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var childEntry= $subject7[$count7];
				this.recursivelyUpdateProcessAreaRoleMap(childEntry, processAreaRoleMap);
			}
		}
		return ;
	},

	_initializeModelEntries: function() {
		this._rootElement= this._createProjectHierarchyTreeItem(this._projectArea, null, true, "projectAreaImage");
		this._addChildren(this._rootElement, this._projectArea.children);
	},

	_addChildren: function(parentTeamAreaEntry, childTeamAreas) {
		if (childTeamAreas == null || childTeamAreas.length === 0) 
			return ;
		var i= 0;
		var $subject8= childTeamAreas;
		var $length8= $subject8.length;
		for (var $count8= 0; $count8 < $length8; $count8++){
			var childTeamArea= $subject8[$count8];
			if (childTeamArea != null) {
				var childTeamAreaEntry= this._createProjectHierarchyTreeItem(childTeamArea, parentTeamAreaEntry, false, "teamAreaImage");
				this._addChildren(childTeamAreaEntry, childTeamArea.children);
				parentTeamAreaEntry.addChild(childTeamAreaEntry, i++);
			}
		}
	},

	_createProjectHierarchyTreeItem: function(processArea, parentProcessArea, isProjectArea, iconClass) {
		var params= {};
		params.processArea= processArea;
		if (parentProcessArea != null) {
			params.processAreaPath= dojo.string.substitute(ProcessSpecificationConstants.PATH_CONCAT_STRING, [parentProcessArea.getProcessAreaPath(), processArea.name]);
		} else {
			params.processAreaPath= processArea.name;
		}
		params.configuredRoles= this._processAreaRoleMap[params.processAreaPath];
		params.isProjectArea= isProjectArea;
		params.model= this;
		params.iconClass= iconClass;
		var projectHierarchyTreeItem= new ProjectHierarchyPermissionItem(params);
		return projectHierarchyTreeItem;
	}
});
var ProjectHierarchyPermissionItem= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.EditComponentsPermissionWidget.ProjectHierarchyPermissionItem", IconItem, {

	//_processArea: null,

	//_processAreaPath: null,

	//_configuredRoles: null,

	//_model: null,

	constructor: function(params) {
		this._processArea= params.processArea;
		this._processAreaPath= params.processAreaPath;
		this._initializeConfiguredRoles(params.configuredRoles);
		this.label= this._getDisplayString();
		this._model= params.model;
	},

	_initializeConfiguredRoles: function(currentConfiguredRoles) {
		this._configuredRoles= [];
		if (this._processArea.roles != null && currentConfiguredRoles != null && currentConfiguredRoles.length > 0) {
			var $subject9= this._processArea.roles;
			var $length9= $subject9.length;
			for (var $count9= 0; $count9 < $length9; $count9++){
				var processRole= $subject9[$count9];
				if (dojo.indexOf(currentConfiguredRoles, processRole.id) !== -1) {
					this._configuredRoles.push(processRole.id);
				}
			}
		}
	},

	getProcessAreaPath: function() {
		return this._processAreaPath;
	},

	getDefinedRoles: function() {
		return this._processArea.roles;
	},

	getConfiguredRoles: function() {
		return this._configuredRoles;
	},

	updateConfiguredRoles: function(configuredRoles) {
		this._configuredRoles= configuredRoles;
		this.label= this._getDisplayString();
		this.update();
		this._model.notifyModelChanged();
	},

	getProcessArea: function() {
		return this._processArea;
	},

	_getDisplayString: function() {
		var displayString= this._processArea.name;
		if (this._configuredRoles != null && this._configuredRoles.length > 0) {
			displayString= dojo.string.substitute(ProcessSpecificationConstants.PROCESS_ROLES_CONCAT_STRING, [this._processArea.name, this._configuredRoles.join(", ")]);
		}
		return jazz.util.html.escape(displayString);
	}
});

})();
