/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverModel");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.scm.web.client.internal.ScmClient");
dojo.require("com.ibm.team.scm.web.ui.internal.process.ProcessSpecificationConstants");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.ComponentsGridViewer");
dojo.require("com.ibm.team.scm.web.ui.internal.process.operationbehavior.MessageDisplayWidget");
dojo.require("dojo.Deferred");

(function() {
var team= com.ibm.team;
var transport= team.repository.web.transport;
var ServiceRequest= transport.ServiceRequest;
var ServiceResponseHandler= transport.ServiceResponseHandler;
var TeamServerClient= transport.TeamServerClient;
var web= team.scm.web;
var ScmClient= web.client.internal.ScmClient;
var process= web.ui.internal.process;
var ProcessSpecificationConstants= process.ProcessSpecificationConstants;
var operationbehavior= process.operationbehavior;
var ComponentsGridViewModel= operationbehavior.ComponentsGridViewer.ComponentsGridViewModel;
var MessageDisplayWidget= operationbehavior.MessageDisplayWidget;

var WorkItemsMatchQueryDeliverModel= dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverModel", null, {
	"-chains-": { constructor: "manual" },

	//_componentID: null,

	//_currentWorkItemOptionId: null,

	//_currentProjectAreaOptionId: null,

	//_currentForeignQueryOptionId: null,

	//_preconditionConfiguration: null,

	//_preconditionPromise: null,

	//_componentsGridViewModel: null,

	//_configuredComponents: null,

	//_configuredQuery: null,

	//_initialConfiguredQueryId: null,

	constructor: function(params) {
		this._componentID= ProcessSpecificationConstants.VAL_TRUE;
		this._currentWorkItemOptionId= ProcessSpecificationConstants.VAL_ALL;
		this._currentProjectAreaOptionId= ProcessSpecificationConstants.VAL_ALLOWED;
		this._currentForeignQueryOptionId= ProcessSpecificationConstants.VAL_RUN_NORMALLY;
		this._initializePreconditionData(params.preconditionString);
	},

	_initializePreconditionData: function(preConditionString) {
		if (preConditionString == null) 
			return ;
		this._preconditionConfiguration= dojo.fromJson(preConditionString);
		if (this._preconditionConfiguration == null || this._preconditionConfiguration.compMatcher == null) 
			return ;
		if (this._preconditionConfiguration.compMatcher['match-all'] != null) {
			if (this._preconditionConfiguration.compMatcher['match-all'] === "true") {
				this._componentID= ProcessSpecificationConstants.VAL_TRUE;
			} else 
				this._componentID= ProcessSpecificationConstants.VAL_FALSE;
		} else {
			this._componentID= ProcessSpecificationConstants.VAL_FALSE;
		}
		if (this._preconditionConfiguration.matchMode != null && this._preconditionConfiguration.matchMode.value !== ProcessSpecificationConstants.VAL_ALL) {
			this._currentWorkItemOptionId= ProcessSpecificationConstants.VAL_SPEFIFIC;
		}
		if (this._preconditionConfiguration.otherProjectAreaPolicy != null && this._preconditionConfiguration.otherProjectAreaPolicy.value !== ProcessSpecificationConstants.VAL_ALLOWED) {
			this._currentProjectAreaOptionId= ProcessSpecificationConstants.VAL_PROHIBITED;
		}
		if (this._preconditionConfiguration.foreignQueryPolicy != null && this._preconditionConfiguration.foreignQueryPolicy.value !== ProcessSpecificationConstants.VAL_RUN_NORMALLY) {
			this._currentForeignQueryOptionId= ProcessSpecificationConstants.VAL_RUN_IN_THIS_PROJECT_AREA;
		}
	},

	getComponentID: function() {
		return this._componentID;
	},

	setComponentID: function(id) {
		this._componentID= id;
	},

	getCurrentWorkItemOptionID: function() {
		return this._currentWorkItemOptionId;
	},

	setCurrentWorkItemOptionID: function(id) {
		this._currentWorkItemOptionId= id;
	},

	getCurrentProjectAreaOptionID: function() {
		return this._currentProjectAreaOptionId;
	},

	setCurrentProjectAreaOptionID: function(id) {
		this._currentProjectAreaOptionId= id;
	},

	getCurrentForeignQueryOptionID: function() {
		return this._currentForeignQueryOptionId;
	},

	setCurrentForeignQueryOptionID: function(id) {
		this._currentForeignQueryOptionId= id;
	},

	getCurrentQuery: function() {
		return this._configuredQuery;
	},

	getInitialConfiguredQueryId: function() {
		return this._initialConfiguredQueryId;
	},

	setCurrentQuery: function(query) {
		this._configuredQuery= query;
	},

	fetchPreConditionDisplayData: function() {
		if (this._preconditionPromise == null) {
			this._preconditionPromise= (new (require("dojo/Deferred")));
			this._loadComponentsInRepository();
		}
		return this._preconditionPromise;
	},

	_loadComponentsInRepository: function() {
		if (this._preconditionConfiguration == null || this._preconditionConfiguration.compMatcher == null || this._preconditionConfiguration.compMatcher.component == null) {
			this._configuredComponents= [];
			this._fetchQueryForItemId();
			return ;
		}
		var onSuccess= dojo.hitch(this, function(result) {
			this._onComponentsFetchSuccess(result);
		});
		var onFailure= dojo.hitch(this, function(result) {
			this._onComponentsFetchFailed(result);
		});
		var inpitUUIDs= [];
		var $subject= this._preconditionConfiguration.compMatcher.component;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var comp= $subject[$count];
			inpitUUIDs.push(comp.uuid);
		}
		if (inpitUUIDs.length > 0) {
			var parameters= {};
			parameters.componentItemIds= inpitUUIDs;
			ScmClient.getComponentsById(new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'), parameters);
		} else {
			this._configuredComponents= [];
			this._fetchQueryForItemId();
		}
	},

	_fetchQueryForItemId: function() {
		if (this._preconditionConfiguration == null || this._preconditionConfiguration.queryId == null || this._preconditionConfiguration.queryId.value == null || this._preconditionConfiguration.queryId.value == null) {
			this._resolveSuccess();
			return ;
		}
		var onSuccess= dojo.hitch(this, function(result) {
			this._onQueryDTOFetchSuccess(result);
		});
		var onFailure= dojo.hitch(this, function(result) {
			this._onComponentsFetchFailed(result);
		});
		this._initialConfiguredQueryId= this._preconditionConfiguration.queryId.value;
		var queryParams= {};
		queryParams.itemId= this._initialConfiguredQueryId;
		WorkItemsMatchQueryDeliverModel.invokeService("getQuery", new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'), queryParams);
	},

	_onComponentsFetchSuccess: function(result) {
		var components= [];
		if (result != null) {
			var resultItems= result.items;
			for (var i= 0; i < resultItems.length; i++){
				components.push(resultItems[i]);
			}
		}
		this._configuredComponents= components;
		this._fetchQueryForItemId();
	},

	_onQueryDTOFetchSuccess: function(result) {
		this._configuredQuery= result;
		this._resolveSuccess();
	},

	_onComponentsFetchFailed: function(result) {
		this._preconditionPromise.reject(MessageDisplayWidget.getJSError(result), true);
	},

	_resolveSuccess: function() {
		this._preconditionPromise.resolve(null, true);
	},

	getConfiguredPreCondition: function() {
		var configuredComponents= this._componentsGridViewModel.getConfiguredComponents();
		var saveData= {};
		saveData.compMatcher= {};
		saveData.compMatcher.component= [];
		if (configuredComponents != null && configuredComponents.length > 0) {
			var $subject2= configuredComponents;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var entry= $subject2[$count2];
				var condition= {};
				condition.uuid= entry.component.itemId;
				saveData.compMatcher.component.push(condition);
			}
		}
		return saveData;
	},

	markDirty: function() {
		this._componentsGridViewModel.markDirty();
	},

	changesPending: function() {
		var hasChanges= false;
		if (this._componentsGridViewModel != null) {
			hasChanges= this._componentsGridViewModel.changesPending();
		}
		return hasChanges;
	},

	createComponentsGridViewModel: function(params) {
		this._componentsGridViewModel= new ComponentsGridViewModel(params);
	},

	getComponentsGridViewModel: function() {
		return this._componentsGridViewModel;
	},

	getPreconditionComponents: function() {
		return this._configuredComponents;
	},

	getPreConditionData: function() {
		var saveData= {};
		var configuredComponents= this._componentsGridViewModel.getConfiguredComponents();
		saveData.compMatcher= {};
		saveData.compMatcher.component= [];
		if (configuredComponents != null && configuredComponents.length > 0) {
			var $subject3= configuredComponents;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var entry= $subject3[$count3];
				var condition= {};
				condition.uuid= entry.component.itemId;
				saveData.compMatcher.component.push(condition);
			}
		}
		saveData.queryId= {};
		saveData.queryId.value= this._configuredQuery != null ? this._configuredQuery.itemId : this._initialConfiguredQueryId;
		saveData.matchMode= {};
		saveData.matchMode.value= this._currentWorkItemOptionId;
		saveData.otherProjectAreaPolicy= {};
		saveData.otherProjectAreaPolicy.value= this._currentProjectAreaOptionId;
		saveData.foreignQueryPolicy= {};
		saveData.foreignQueryPolicy.value= this._currentForeignQueryOptionId;
		saveData.compMatcher['match-all']= this._componentID;
		return saveData;
	}
});
dojo.declare("com.ibm.team.scm.web.ui.internal.process.operationbehavior.WorkItemsMatchQueryDeliverModel.WorkItemsMatchQueryDeliverModelParams", null, {
	"-chains-": { constructor: "manual" },

	//preconditionString: null
});

WorkItemsMatchQueryDeliverModel.invokeService= function(serviceName, responseHandler, params) {
	var serviceRequest= new ServiceRequest("com.ibm.team.workitem.common.internal.rest.IQueryRestService", serviceName, params);
	TeamServerClient.invokeService(serviceRequest, responseHandler);
};

})();
