/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.mvvm.Util"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.Severity"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.Status"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.ExceptionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.rest.TeamRepositoryException"); //$NON-NLS-1$
dojo.require("dojo.Deferred"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var WidgetMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var team= com.ibm.team;
var ServiceResponseHandler= team.repository.web.transport.ServiceResponseHandler;
var common= team.rtc.foundation.api.common;
var Severity= common.Severity;
var Status= common.Status;
var internal= team.workitem.web.client.internal;
var ExceptionHelper= internal.ExceptionHelper;
var WorkItemClient= internal.WorkItemClient;
var TeamRepositoryException= internal.rest.TeamRepositoryException;

var Util= dojo.declare("com.ibm.team.workitem.web.mvvm.Util", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" }
});

Util.NONAPPLICABLE_VALUE_STATUS= new Status(Severity.ERROR, WidgetMessages.validationNotApplicable);
Util.ERROR_VALIDATING_CONTRIBUTOR= "Problems validating contributor {0}"; //$NON-NLS-1$
Util.isMemberOf= function(projectAreaItemId, currentContributor) {
	var promise= (new (require("dojo/Deferred"))); //$NON-NLS-1$
	try {
		var onSuccess= function(result) {
			promise.resolve(("true" === result)); //$NON-NLS-1$
		};
		var onFailure= function(result) {
			promise.reject(Util.createContributorError(currentContributor));
		};
		var responseHandler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		var parms= {};
		parms.projectAreaItemId= projectAreaItemId;
		parms.contributorItemId= currentContributor.getItemId();
		WorkItemClient.getIsContributorMemberOf(responseHandler, parms);
	} catch (e) {
		if (e instanceof TeamRepositoryException) {
			ExceptionHelper.logException(dojo.string.substitute(Util.ERROR_VALIDATING_CONTRIBUTOR, [currentContributor.getItemId()]), e);
		} else {
			throw e;
		}
	}
	return promise;
};
Util.createContributorError= function(currentContributor) {
	var error= new Error();
	error.message= dojo.string.substitute(Util.ERROR_VALIDATING_CONTRIBUTOR, [currentContributor.getItemId()]);
	return error;
};

})();
