/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2007, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.mvvm.model.AttributeModel"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojox.util.ArrayList"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.Severity"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.Status"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.common.model.IContributor"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.EventSource"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.Attribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.ExceptionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.SafeValueProvider"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.model.types.AttributeTypes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.mvvm.Util"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.mvvm.model.AttributeModelListeners"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("dojo.Deferred"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var lang= com.ibm.jdojo.lang;
var Exception= lang.Exception;
var JavaScriptException= lang.JavaScriptException;
var jdojo= lang.Runtime;
var ArrayList= com.ibm.jdojox.util.ArrayList;
var team= com.ibm.team;
var foundation= team.rtc.foundation;
var common= foundation.api.common;
var Severity= common.Severity;
var Status= common.Status;
var IContributor= common.model.IContributor;
var EventSource= foundation.web.EventSource;
var web= team.workitem.web;
var internal= web.client.internal;
var Attribute= internal.Attribute;
var ExceptionHelper= internal.ExceptionHelper;
var SafeValueProvider= internal.SafeValueProvider;
var AttributeTypes= web.model.types.AttributeTypes;
var mvvm= web.mvvm;
var Util= mvvm.Util;
var AttributeModelListeners= mvvm.model.AttributeModelListeners;
var EventTopics= web.ui.internal.page.EventTopics;

dojo.declare("com.ibm.team.workitem.web.mvvm.model.AttributeModel", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	//_attributeId: null,

	//_attributeLabel: null,

	//_attributeTypeId: null,

	//_hasValueSet: null,

	//_workItem: null,

	//_attribute: null,

	//_attributeType: null,

	//_valueProvider: null,

	//_isAttributeReadOnly: null,

	//_isAttributeRequired: null,

	//_originalValue: null,

	//_currentValue: null,

	//_nullValue: null,

	//_currentValueSet: null,

	//_currentStatus: null,

	//_valueSetPromise: null,

	//valueSetChangedPromise: null,

	//_valueChangedListeners: null,

	//_valueSetChangedListeners: null,

	//_validityChangedListeners: null,

	//_readOnlyChangedListeners: null,

	//_requiredPropertChangedListeners: null,

	//_modelSyncListeners: null,

	//_workItemAttributeChangedListener: null,

	//_workItemDependencyChangedListener: null,

	//_workItemPreSaveListener: null,

	//_readonlyPropsChangedHandle: null,

	//_requiredPropsChangedHandle: null,

	constructor: function(params) {
		this._isAttributeReadOnly= false;
		this._isAttributeRequired= false;
		this.valueSetChangedPromise= new EventSource();
		this._valueChangedListeners= new AttributeModelListeners();
		this._valueSetChangedListeners= new AttributeModelListeners();
		this._validityChangedListeners= new AttributeModelListeners();
		this._readOnlyChangedListeners= new AttributeModelListeners();
		this._requiredPropertChangedListeners= new AttributeModelListeners();
		this._modelSyncListeners= new AttributeModelListeners();
		this._attributeId= params.attributeId;
		this._attributeLabel= params.attributeLabel;
		this._attributeTypeId= params.attributeTypeId;
		this._attributeType= AttributeTypes.getAttributeType(params.attributeTypeId);
		this._workItem= params.workItem;
		this._attribute= this._workItem.getAttribute(this._attributeId);
		this._valueProvider= this._attribute.getValueProvider();
		this._hasValueSet= this._workItem.hasValueSet(this._attributeId);
		this._nullValue= AttributeTypes.toValue(this._attributeType, this._attribute.getNullValue());
		this._syncCurrentValues();
		this._workItemAttributeChangedListener= this._workItem.addAttributeChangedListener(this._attributeId, dojo.hitch(this, "_handleAttributeChanged")); //$NON-NLS-1$
		this._workItemDependencyChangedListener= this._workItem.addDependencyChangedListener(this._attributeId, dojo.hitch(this, "_handleDependencyChanged")); //$NON-NLS-1$
		this._workItemPreSaveListener= this._workItem.onPreSave().addListener(dojo.hitch(this, function(callbackArg) {
			this.syncValues();
		}));
		this._readonlyPropsChangedHandle= dojo.subscribe(EventTopics.WORKITEM_READ_ONLY_PROPERTIES_CHANGED, this, dojo.hitch(this, "_handleReadOnlyPropertyChanged")); //$NON-NLS-1$
		this._requiredPropsChangedHandle= dojo.subscribe(EventTopics.WORKITEM_REQUIRED_PROPERTIES_CHANGED, this, dojo.hitch(this, "_handleRequiredPropertyChanged")); //$NON-NLS-1$
		var promise= (new (require("dojo/Deferred"))); //$NON-NLS-1$
		this._valueSetPromise= promise.resolve(new ArrayList());
	},

	/**
	 * @deprecated
	 */
	_getAttribute: function() {
		return this._attribute;
	},

	populateValues: function() {
		this._syncCurrentValues();
		var valueSetEventEmmited= false;
		if (this._hasValueSet) {
			valueSetEventEmmited= this._retrieveValueSet(true);
		}
		if (!valueSetEventEmmited) {
			this._valueChangedListeners.notifyListeners({newValue: this._currentValue, oldValue: this._currentValue, isNullValue: this.isNullValue(), currentValueSet: this._currentValueSet});
			this._handleValidityChanged();
		}
	},

	syncValues: function() {
		this._modelSyncListeners.notifyListeners(this._currentValue);
	},

	_syncCurrentValues: function() {
		this._currentValue= this._originalValue= this._workItem.getValue(this._attributeId);
		this._currentValueSet= null;
		this._currentStatus= Status.OK_STATUS;
	},

	isDirty: function() {
		return this._originalValue == null ? this._currentValue != null : !this._attributeType.compareValue(this._originalValue, this._currentValue);
	},

	getCurrentStatus: function() {
		return this._currentStatus;
	},

	_handleAttributeChanged: function(attributeChangedEvent) {
		var newModelValue= AttributeTypes.toValue2(this._attributeType, attributeChangedEvent.attributeValue, this._nullValue);
		if (this._attributeType.compareValue(newModelValue, this._currentValue)) {
			if (this._attributeTypeId !== 'tags') { //$NON-NLS-1$
				console.warn("[New API Debug] Attribute changed event emitted on a non-chnaged attribute."); //$NON-NLS-1$
			}
			return ;
		}
		var oldValue= this._currentValue;
		this._currentValue= newModelValue;
		this._valueChangedListeners.notifyListeners({newValue: this._attributeType.copy(newModelValue), oldValue: oldValue, isNullValue: this.isNullValue(), currentValueSet: this._currentValueSet});
		this._handleValidityChanged();
	},

	_handleValueWhenDependencyChanged: function(valueSet) {
		if (this._attributeType.getScriptValueResolver() == null) {
			this._workItem.updateValue(this._attributeId);
		} else {
			try {
				var wrapper= new SafeValueProvider(this._valueProvider.instantiate(), this._attributeType.getScriptValueResolver(), valueSet);
				this.setValue(wrapper.getValue(this._attributeId, this._workItem.getScriptSourceWorkItem(), this._valueProvider.getContext()));
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					ExceptionHelper.logException(dojo.string.substitute("Problems executing value provider for {0}", [this._valueProvider.getScriptClass()]), e); //$NON-NLS-1$
				} else {
					throw e;
				}
			}
		}
	},

	_handleValidityChanged: function(validationStatus) {
		validationStatus= validationStatus != null ? validationStatus : this._workItem.validate(this._attributeId);
		if (validationStatus.isOK()) {
			var isApplicableValue= this.isApplicableValue();
			var validationStatusParam= validationStatus;
			validationStatus= !this._requiresApplicabilityWarning() || isApplicableValue ? validationStatus : Util.NONAPPLICABLE_VALUE_STATUS;
			if (!isApplicableValue && this._requiresServerContributorValidation()) {
				var currentContributor= this._currentValue;
				Util.isMemberOf(this._workItem.getProjectAreaItemId(), currentContributor).then(dojo.hitch(this, function(isMemberOfProject) {
					this._handleStatus(isMemberOfProject ? validationStatusParam : Util.NONAPPLICABLE_VALUE_STATUS);
					return isMemberOfProject;
				})).otherwise(function(error) {
					ExceptionHelper.logError(error.message);
					return error;
				});
				return ;
			}
		}
		this._handleStatus(validationStatus);
	},

	_requiresServerContributorValidation: function() {
		return this._attributeTypeId === 'contributor' && this._currentValueSet != null && this._currentValueSet.size() === Attribute.CONTRIBUTOR_LIMIT + 1 && jdojo.isInstance(this._currentValue, IContributor); //$NON-NLS-1$
	},

	_handleStatus: function(validationStatus) {
		if (!this._currentStatus.isEqual(validationStatus)) {
			this._currentStatus= validationStatus;
			this._validityChangedListeners.notifyListeners(this._currentStatus);
		}
	},

	_requiresApplicabilityWarning: function() {
		return AttributeTypes.isEnumerationType(this._attributeTypeId) || this._attributeTypeId === 'contributor' || this._attributeTypeId === 'interval' || AttributeTypes.isStringType(this._attributeTypeId); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_handleReadOnlyPropertyChanged: function( /*, args... */ ) {
		var args= Array.prototype.slice.call(arguments, 0);
		var isReadOnly= args[0] && args[0].readOnlyAttributes && args[0].readOnlyAttributes[this._attributeId] || this._workItem.isReadOnly(this._attributeId);
		if (this.isDirty() && isReadOnly) {
			return ;
		}
		this._isAttributeReadOnly= isReadOnly;
		this._readOnlyChangedListeners.notifyListeners(isReadOnly);
	},

	_handleRequiredPropertyChanged: function( /*, args... */ ) {
		var isRequired= this._workItem.isRequired(this._attributeId);
		this._isAttributeRequired= isRequired;
		this._requiredPropertChangedListeners.notifyListeners(isRequired);
	},

	_handleDependencyChanged: function(attributeChangedEvent) {
		if (this._hasValueSet) {
			this._retrieveValueSet(true);
			if (this._valueProvider != null) {
				this._valueSetPromise.then(dojo.hitch(this, function(valueSet) {
					this._handleValueWhenDependencyChanged(valueSet);
					return valueSet;
				})).otherwise(function(object) {
					console.error(object);
					return object;
				});
			}
		} else {
			if (this._valueProvider != null) {
				this._handleValueWhenDependencyChanged(new ArrayList());
			}
			this._handleValidityChanged();
		}
	},

	addValueSetChangedListener: function(valueSetChangedCallback) {
		return this._valueSetChangedListeners.addListener(valueSetChangedCallback);
	},

	addAttributeValueChangedListener: function(valueChangedCallback) {
		return this._valueChangedListeners.addListener(valueChangedCallback);
	},

	addModelSyncListener: function(modelSyncCallback) {
		return this._modelSyncListeners.addListener(modelSyncCallback);
	},

	addValidityChangedListener: function(validityChangedCallback) {
		return this._validityChangedListeners.addListener(validityChangedCallback);
	},

	addReadOnlyChangedListener: function(readOnlyChangedCallback) {
		return this._readOnlyChangedListeners.addListener(readOnlyChangedCallback);
	},

	addRequiredPropertyChangedListener: function(requiredPropertyChangedCallback) {
		return this._requiredPropertChangedListeners.addListener(requiredPropertyChangedCallback);
	},

	sameValue: function(value) {
		return this._attributeType.compareValue(this._currentValue, value);
	},

	setValue: function(value) {
		return this._workItem.setValue(this._attributeId, value);
	},

	clearAttributeValue: function() {
		this.setValue(this._nullValue);
	},

	getAttributeId: function() {
		return this._attributeId;
	},

	getAttributeTypeId: function() {
		return this._attributeTypeId;
	},

	getAttributeType: function() {
		return this._attributeType;
	},

	getAttributeLabel: function() {
		return this._attributeLabel;
	},

	getValue: function() {
		return this._attributeType.copy(this._currentValue);
	},

	getAttributeValueSet: function() {
		return this._currentValueSet;
	},

	getNullValue: function() {
		return this._nullValue;
	},

	hasValueSet: function() {
		return this._hasValueSet;
	},

	isNullValue: function() {
		return this._currentValue == null || this._attributeType.compareValue(this._currentValue, this._nullValue);
	},

	isReadOnly: function() {
		return this._isAttributeReadOnly;
	},

	isApplicableValue: function(value) {
		return !this._hasValueSet || this.isNullValue() || this._currentValueSet == null || this._currentValueSet.contains(value != null ? value : this._currentValue);
	},

	getValueSetPromise: function() {
		return this._valueSetPromise;
	},

	_retrieveValueSet: function(refresh) {
		this._valueSetPromise= this._workItem.getAttributeValueSet(this._attributeId, {forceFetch: refresh});
		this.valueSetChangedPromise.fire(null);
		this._valueSetPromise.then(dojo.hitch(this, function(newValueSet) {
			var oldValueSet= this._currentValueSet;
			this._currentValueSet= newValueSet;
			this._valueSetChangedListeners.notifyListeners({currentValue: this._currentValue, isNullValue: this.isNullValue(), oldValueSet: oldValueSet, newValueSet: newValueSet});
			this._handleValidityChanged();
			return newValueSet;
		}), dojo.hitch(this, function(error) {
			this._handleValidityChanged(new Status(Severity.ERROR, error.message));
			return error;
		}));
		return this._valueSetPromise.isFulfilled();
	},

	destroy: function() {
		if (this._workItemAttributeChangedListener != null) {
			this._workItemAttributeChangedListener();
			this._workItemAttributeChangedListener= null;
		}
		if (this._workItemDependencyChangedListener != null) {
			this._workItemDependencyChangedListener();
			this._workItemDependencyChangedListener= null;
		}
		if (this._workItemPreSaveListener != null) {
			this._workItemPreSaveListener.destroy();
			this._workItemPreSaveListener= null;
		}
		if (this._readonlyPropsChangedHandle != null) {
			dojo.unsubscribe(this._readonlyPropsChangedHandle);
			this._readonlyPropsChangedHandle= null;
		}
		if (this._requiredPropsChangedHandle != null) {
			dojo.unsubscribe(this._requiredPropsChangedHandle);
			this._requiredPropsChangedHandle= null;
		}
	}
});

})();
